#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "gv4l.h"
#include "interface.h"
#include "support.h"

extern GtkWidget *gv4l; //is initialized in main.c
extern char config_file[250]; //config file variable from main.c
extern gboolean record; //record on startup var from main.c
gchar sch_file[250] = "/tmp/gv4l-schedule"; //the schedule file
//variables for the columned list (they gotta be global =\)
char enabled[250], value[250];

//execute on startup
void on_gv4l_show (GtkWidget * widget, gpointer user_data)
{

  //variables definition
  FILE *inFile;
  FILE *outFile;
  
  gchar *home = g_get_home_dir();
  gchar xawtv[250];
  gchar player[250]="none";
  gchar rec_dur[250]="";

  gchar vdev_val[250];
  gchar adev_val[250];
  gchar p_size[250];
  gchar fps_val[250];
  gchar cod_val[250];
  gchar chan_val[250];
  gchar file_val[250];
  gchar vbit_val[250];
  gchar abit_val[250];
  gchar agn_val[250];
  gchar deinter[250];
  gint prev_val;
  
  //lookup the widgets
  GtkWidget *vdev = lookup_widget (GTK_WIDGET (widget), "vdev_val");
  GtkWidget *adev = lookup_widget (GTK_WIDGET (widget), "adev_val");
  GtkWidget *size = lookup_widget (GTK_WIDGET (widget), "p_size");
  GtkWidget *fps = lookup_widget (GTK_WIDGET (widget), "fps_val");
  GtkWidget *cod = lookup_widget (GTK_WIDGET (widget), "combo_entry1");
  GtkWidget *chan = lookup_widget (GTK_WIDGET (widget), "chan_val");
  GtkWidget *file = lookup_widget (GTK_WIDGET (widget), "file_val");
  GtkWidget *vbit = lookup_widget (GTK_WIDGET (widget), "vbit_val");
  GtkWidget *abit = lookup_widget (GTK_WIDGET (widget), "abit_val");
  GtkWidget *agn = lookup_widget (GTK_WIDGET (widget), "agn_val");
  GtkWidget *prev = lookup_widget (GTK_WIDGET (widget), "prev_val");
  GtkWidget *inter = lookup_widget (GTK_WIDGET (widget), "de_inter");
  GtkWidget *rec = lookup_widget (GTK_WIDGET (widget), "recTime");
  GtkWidget *status = lookup_widget (GTK_WIDGET (widget), "status");
  GtkStyle *style = gtk_style_new();
  //set the status color
  GdkColor  green = {0, 0, 35335, 0};
    

  system ("rm -rf /tmp/player-gv4l"); //remove temp file

  //see if we got xawtv configuration file
  strcpy(xawtv, home);
  strcat(xawtv, "/.xawtv");
  if (fopen(xawtv, "r") == NULL)
  {
    GtkWidget *no_xawtv;
    no_xawtv = create_no_xawtv ();
    gtk_widget_show (no_xawtv);
  }
  
  //load the configuration from file (if exists)
  if (fopen (config_file, "r") != NULL)
  {
      inFile = fopen (config_file, "r");
      fscanf (inFile, "%s%s%s%s%s%s%s%s%s%s%d%s%s%s", vdev_val, adev_val, p_size,
	      fps_val, cod_val, vbit_val, abit_val, agn_val, chan_val,
	      file_val, &prev_val, player, deinter, rec_dur);
      fclose (inFile);
      if (player!=NULL)
      {
       outFile = fopen ("/tmp/player-gv4l", "w");
       fprintf (outFile,"%s\n",player);
       fclose (outFile);
      }
  }
  else //set defaults
  {
      strcpy (vdev_val, "/dev/video0");
      strcpy (adev_val, "/dev/dsp");
      strcpy (p_size, "384x288");
      strcpy (fps_val, "28");
      strcpy (cod_val, "divx5");
      strcpy (vbit_val, "1800,250,100");
      strcpy (abit_val, "96,0,5");
      strcpy (agn_val, "5");
      strcpy (chan_val, "0,53");

      strcpy (file_val, home);
      strcat (file_val, "/video.avi");
      
      prev_val = 1;
      strcpy (deinter, "0");
      system("echo none > /tmp/player-gv4l");
  }

  //load the values
  gtk_entry_set_text (GTK_ENTRY (vdev), vdev_val);
  gtk_entry_set_text (GTK_ENTRY (adev), adev_val);
  gtk_entry_set_text (GTK_ENTRY (size), p_size);
  gtk_entry_set_text (GTK_ENTRY (fps), fps_val);
  gtk_entry_set_text (GTK_ENTRY (cod), cod_val);
  gtk_entry_set_text (GTK_ENTRY (chan), chan_val);
  gtk_entry_set_text (GTK_ENTRY (file), file_val);
  gtk_entry_set_text (GTK_ENTRY (vbit), vbit_val);
  gtk_entry_set_text (GTK_ENTRY (abit), abit_val);
  gtk_entry_set_text (GTK_ENTRY (agn), agn_val);
  gtk_entry_set_text (GTK_ENTRY (inter), deinter);
  gtk_entry_set_text (GTK_ENTRY (rec), rec_dur);
  if (prev_val == 1)
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (prev), TRUE);
  else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (prev), FALSE);

  //set Idle status
  if (fopen ("/tmp/trr", "r") == NULL)
  {
     style->fg[GTK_STATE_NORMAL] = green;
     // style->font = gdk_font_load("10x20");
     gtk_entry_set_text(GTK_ENTRY (status), "Idle.");
     gtk_widget_set_style(GTK_WIDGET (status), style);
  }
  //check if we should start recording
  if (record == 1)
  {
	  on_start_clicked ((GtkButton *) widget, widget);
	  record = 0;
  }
}





//automatic file extension function
gboolean
on_combo_entry1_focus_out_event        (GtkWidget       *widget,
                                        GdkEventFocus   *event,
                                        gpointer         user_data)
{
  gchar file_val[250], cod_val[250], *noext, *ext, notilde[250];
  gchar *home = g_get_home_dir();

  //lookup and store values
  GtkWidget *file = lookup_widget (GTK_WIDGET (widget), "file_val");
  GtkWidget *cod = lookup_widget (GTK_WIDGET (widget), "combo_entry1");
  strncpy (cod_val, gtk_entry_get_text (GTK_ENTRY (cod)), 250);
  strncpy (file_val, gtk_entry_get_text (GTK_ENTRY (file)), 250);
  
  //check for "~"
  if (strchr (file_val, '~'))
  {
	strcpy (notilde, file_val);
	strcpy (file_val, home);
	strcat (file_val, "/");
  	noext = strstr (notilde, "~");
 	strncpy (noext, ".", 1);
	strcat (file_val, noext);	
  	gtk_entry_set_text (GTK_ENTRY (file), file_val);
  }
   
  
  //if no file set to untitled
  if (strlen (file_val)==0)
  {
  	strcpy (file_val, home);
  	strcat (file_val, "/untitled");
  }
  
  //put .avi extension if there's no "."
  if (strrchr (file_val, '.')==NULL)
  {
  	strcat (file_val, ".avi");
  	gtk_entry_set_text (GTK_ENTRY (file), file_val);
  }
  
  //put .avi if there's unknown extension
  if (strstr (file_val, ".avi")==NULL && strstr (file_val, ".mpg")==NULL)
  {
  	strcat (file_val, ".avi");
  	gtk_entry_set_text (GTK_ENTRY (file), file_val);
  }
  
  //see where the last "." in the name is
  ext = strrchr (file_val, '.');

  //if codec is not mpeg and we got .mpg put .avi
  if (strcmp (cod_val, "ffmpeg4")!=0 && strcmp (ext, ".mpg")==0)
  {
  	noext = strstr (file_val, ".mpg");
  	strncpy (noext, ".avi", 4);
  	gtk_entry_set_text (GTK_ENTRY (file), file_val);
  	return 0;
  }
  //do nothing if we got the right one
  else if (strcmp (cod_val, "ffmpeg4")!=0 && strcmp (ext, ".avi")==0 )
  	  return 0;
  
  //if we got other codec put .avi
  else if (strcmp (cod_val, "ffmpeg4")!=0)
  {
  	strncpy (file_val, ".avi", 4);
  	gtk_entry_set_text (GTK_ENTRY (file), file_val);
  	return 0;
  }

  //if we got mpeg w/ .avi put .mpg
  else if (strcmp (cod_val, "ffmpeg4")==0 && strcmp (ext, ".avi")==0)
  {
  	noext = strstr (file_val, ".avi");
  	strncpy (noext, ".mpg",4);
  	gtk_entry_set_text (GTK_ENTRY (file), file_val);
  	return 0;
  }
  //do nothing if we got the right ext for mpeg
  else if (strcmp (cod_val, "ffmpeg4")==0 && strcmp (ext, ".mpg")==0 )
	  return 0;

  //if we got .mpg for anything else, put .avi instead
  else if (strcmp (ext, ".mpg")==0)
  {
  	noext = strstr (file_val,".mpg");
  	strncpy (noext, ".avi", 4);
  	gtk_entry_set_text (GTK_ENTRY (file), file_val);
  	return 0;
  }

  return FALSE;
}





//watch function
void on_watch_clicked (GtkButton * button, gpointer user_data)
{
  //define variables
  FILE *outFile;

  gchar vdev_val[250];
  gchar adev_val[250];
  gchar p_size[250] = "-g ";
  gchar fps_val[250] = "-f ";
  gchar chan_val[250];
  gchar deinter[250] = "-I ";
  gboolean prev_val;
  //lookup widgets
  GtkWidget *vdev = lookup_widget (GTK_WIDGET (button), "vdev_val");
  GtkWidget *adev = lookup_widget (GTK_WIDGET (button), "adev_val");
  GtkWidget *size = lookup_widget (GTK_WIDGET (button), "p_size");
  GtkWidget *fps = lookup_widget (GTK_WIDGET (button), "fps_val");
  GtkWidget *chan = lookup_widget (GTK_WIDGET (button), "chan_val");
  GtkWidget *prev = lookup_widget (GTK_WIDGET (button), "prev_val");
  GtkWidget *inter = lookup_widget (GTK_WIDGET (button), "de_inter");
  
  GtkWidget *status = lookup_widget (GTK_WIDGET (button), "status");
  GtkStyle *style = gtk_style_new();
  GtkStyle *style0 = gtk_style_new();
  GdkColor  blue = {0, 0, 0, 65335};
  GdkColor  green = {0, 0, 35335, 0};

  strncpy (vdev_val, gtk_entry_get_text (GTK_ENTRY (vdev)), 250);
  strncpy (adev_val, gtk_entry_get_text (GTK_ENTRY (adev)), 250);

  //check if pic size is set
  strcat (p_size, gtk_entry_get_text (GTK_ENTRY (size)));
  if (strcmp (p_size, "-g ")==0)
  	strcpy (p_size, " ");
  
  //check if fps is set
  strcat (fps_val, gtk_entry_get_text (GTK_ENTRY (fps)));
  if (strcmp (fps_val, "-f ")==0)
  	strcpy (fps_val, " ");
  
  //check if preview is set
  strncpy (chan_val, gtk_entry_get_text (GTK_ENTRY (chan)), 250);
  prev_val = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (prev));

  //error if no video dev set
  if (strlen (vdev_val)==0)
  {
  	GtkWidget *novid;
  	novid = create_novid ();
  	gtk_widget_show (novid);
  	on_stop_clicked ((GtkButton *) button, button);
  	exit;
  }
  //error if no audio dev set
  if (strlen (adev_val)==0)
  {
  	GtkWidget *noaud;
  	noaud = create_noaud ();
  	gtk_widget_show (noaud);
  	on_stop_clicked ((GtkButton *) button, button);
  	exit;
  }
  //error if no source set
  if(strlen(chan_val)==0)
  {
  	GtkWidget *nosrc;
  	nosrc = create_nosrc ();
  	gtk_widget_show (nosrc);
  	on_stop_clicked ((GtkButton *) button, button);
  	exit;
  }
  //see if de-interlace is set
  if ( atoi(gtk_entry_get_text (GTK_ENTRY (inter))) > 0 && atoi(gtk_entry_get_text (GTK_ENTRY (inter))) < 4)
	strcat (deinter, gtk_entry_get_text (GTK_ENTRY (inter)));
  else
	strcpy (deinter, "");



  //stop transcode if running
  system ("killall -2 transcode 2>/dev/null || echo Done > /tmp/gv4l.temp");
  system ("killall -9 gv4l-sleep.sh 2>/dev/null");

  //wait until scripts are done
  do
  {
  	system ("sleep 0.5 2>/dev/null || sleep 0,5");
  }
  while (fopen ("/tmp/gv4l.temp", "r") == NULL);
  system ("sleep 0.1 2>/dev/null || sleep 0,1");
  //remove temp files
  system ("rm -rf /tmp/gv4l*");

  //write new script
  outFile = fopen ("/tmp/gv4l.sh", "w");
  fprintf (outFile, "#!/bin/bash\n");
  fprintf (outFile,
	   "transcode -i %s -p %s -V -u 100 %s %s --import_v4l %s %s %s\n",
	   vdev_val, adev_val, p_size, fps_val, chan_val, deinter,
	   prev_val == TRUE ? "-J preview" : "");
  fprintf (outFile, "echo Done > /tmp/gv4l.temp\n");
  fclose (outFile);

  //start script
  system ("chmod +x /tmp/gv4l.sh");
  system ("/tmp/gv4l.sh&");
  sleep (1);

  //remove check file
  system("rm -rf /tmp/trr");
  //create check file if transcode is running
  system ("ps -A|grep transcode >/tmp/trr || rm -rf /tmp/trr");

  //set new status
  style->fg[GTK_STATE_NORMAL] = blue;
  // style->font = gdk_font_load("10x20");
  gtk_entry_set_text(GTK_ENTRY (status), "Playing Stream from Device...");
  gtk_widget_set_style(GTK_WIDGET (status), style);

  //reset status if transcode not running
  if (fopen ("/tmp/trr", "r") == NULL)
  {
  	style0->fg[GTK_STATE_NORMAL] = green;
  	// style->font = gdk_font_load("10x20");
  	gtk_entry_set_text(GTK_ENTRY (status), "Idle.");
  	gtk_widget_set_style(GTK_WIDGET (status), style0);
  }

}

//call watch function from menu
void
on_watch_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  on_watch_clicked ((GtkButton *) menuitem, menuitem);
}
	
	
	
	

//record function
void
on_start_clicked (GtkButton * button, gpointer user_data)
{
  //define variables
  FILE *outFile;

  gchar vdev_val[250];
  gchar adev_val[250];
  gchar p_size[250]="-g ";
  gchar fps_val[250]="-f ";
  gchar cod_val[250];
  gchar chan_val[250];
  gchar file_val[250];
  gchar vbit_val[250]="-w ";
  gchar abit_val[250]="-b ";
  gchar agn_val[250]="-s ";
  gchar deinter[250]="-I ";
  gchar rec_dur[250];
  int duration;
  gboolean prev_val;
  //lookup widgets
  GtkWidget *vdev = lookup_widget (GTK_WIDGET (button), "vdev_val");
  GtkWidget *adev = lookup_widget (GTK_WIDGET (button), "adev_val");
  GtkWidget *size = lookup_widget (GTK_WIDGET (button), "p_size");
  GtkWidget *fps = lookup_widget (GTK_WIDGET (button), "fps_val");
  GtkWidget *cod = lookup_widget (GTK_WIDGET (button), "combo_entry1");
  GtkWidget *chan = lookup_widget (GTK_WIDGET (button), "chan_val");
  GtkWidget *file = lookup_widget (GTK_WIDGET (button), "file_val");
  GtkWidget *vbit = lookup_widget (GTK_WIDGET (button), "vbit_val");
  GtkWidget *abit = lookup_widget (GTK_WIDGET (button), "abit_val");
  GtkWidget *agn = lookup_widget (GTK_WIDGET (button), "agn_val");
  GtkWidget *prev = lookup_widget (GTK_WIDGET (button), "prev_val");
  GtkWidget *rec = lookup_widget (GTK_WIDGET (button), "recTime");
  GtkWidget *inter = lookup_widget (GTK_WIDGET (button), "de_inter");

  GtkWidget *status = lookup_widget (GTK_WIDGET (button), "status");
  GtkStyle *style = gtk_style_new();
  GtkStyle *style0 = gtk_style_new();
  GdkColor  red = {0, 45335, 0, 0};
  GdkColor  green = {0, 0, 35335, 0};

  strncpy (vdev_val, gtk_entry_get_text (GTK_ENTRY (vdev)), 250);
  strncpy (adev_val, gtk_entry_get_text (GTK_ENTRY (adev)), 250);
  strncpy (rec_dur, gtk_entry_get_text (GTK_ENTRY (rec)), 250);
  //convert record dutation to integer value
  duration = atoi(rec_dur);
  
  //check if pic size is set
  strcat (p_size, gtk_entry_get_text (GTK_ENTRY (size)));
  if (strcmp (p_size, "-g ")==0)
  	strcpy (p_size, " ");
  
  //check if fps is set
  strcat (fps_val, gtk_entry_get_text (GTK_ENTRY (fps)));
  if (strcmp (fps_val, "-f ")==0)
  	strcpy (fps_val, " ");
  
  strncpy (cod_val, gtk_entry_get_text (GTK_ENTRY (cod)), 250);
  strncpy (chan_val, gtk_entry_get_text (GTK_ENTRY (chan)), 250);
  on_combo_entry1_focus_out_event ((GtkWidget *) button, NULL, button);
  strncpy (file_val, gtk_entry_get_text (GTK_ENTRY (file)), 250);

  //check if vid bitrate is set
  strcat (vbit_val, gtk_entry_get_text (GTK_ENTRY (vbit)));
  if (strcmp (vbit_val, "-w ")==0)
  	strcpy (vbit_val, " ");
  
  //check if audio dev is set
  strcat (abit_val, gtk_entry_get_text (GTK_ENTRY (abit)));
  if (strcmp (abit_val, "-b ")==0)
  	strcpy (abit_val, " ");
  
  //check if audio gain is set
  strcat (agn_val, gtk_entry_get_text (GTK_ENTRY (agn)));
  if (strcmp (agn_val, "-s ")==0)
  	strcpy(agn_val, " ");
  //see if de-interlace is set
  if ( atoi(gtk_entry_get_text (GTK_ENTRY (inter))) > 0 && atoi(gtk_entry_get_text (GTK_ENTRY (inter))) < 4)
	strncat (deinter, gtk_entry_get_text (GTK_ENTRY (inter)), 250);
  else
	strncpy (deinter, "", 250);
  
  
  prev_val = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (prev));

  //stop transcode if running
  system ("killall -2 transcode 2>/dev/null || echo Done > /tmp/gv4l.temp");
  system ("killall -9 gv4l-sleep.sh 2>/dev/null");
  //wait until scripts are done
  do
    {
      system ("sleep 0.5 2>/dev/null || sleep 0,5");
    }
  while (fopen ("/tmp/gv4l.temp", "r") == NULL);
  system ("sleep 0.1 2>/dev/null || sleep 0,1");
  //remove temp files
  system ("rm -rf /tmp/gv4l*");

  
  // Check if all required fields are filled
    if (strlen (vdev_val)==0)
  {
  	GtkWidget *novid;
  	novid = create_novid ();
  	gtk_widget_show (novid);
  	on_stop_clicked ((GtkButton *) button, button);
  	exit;
  }
  if (strlen (adev_val)==0)
  {
  	GtkWidget *noaud;
  	noaud = create_noaud ();
  	gtk_widget_show (noaud);
  	on_stop_clicked ((GtkButton *) button, button);
  	exit;
  }
  if (strlen (cod_val)==0)
  {
  	GtkWidget *nocod;
  	nocod = create_nocod ();
  	gtk_widget_show (nocod);
  	on_stop_clicked ((GtkButton *) button, button);
  	exit;
  }
  else if (strcmp (cod_val, "ffmpeg4")==0)
  {
	strcpy (cod_val, "ffmpeg -F mpeg4");
	printf ("%s\n", cod_val);
  }
  
  if (strlen (chan_val)==0)
  {
  	GtkWidget *nosrc;
  	nosrc = create_nosrc ();
  	gtk_widget_show (nosrc);
  	on_stop_clicked ((GtkButton *) button, button);
  	exit;
  }
  // End Fields Check
  

  //write new script
  if (fopen (file_val, "r") == NULL) //don't resume
  {
  	outFile = fopen ("/tmp/gv4l.sh", "w");
  	fprintf (outFile, "#!/bin/bash\n");
  	fprintf (outFile,
		"transcode -i %s -p %s -V -u 100 %s %s -y %s --import_v4l %s -o %s %s %s %s %s %s",
		vdev_val, adev_val, p_size, fps_val, cod_val, chan_val,
		file_val, vbit_val, abit_val, agn_val, deinter,
		prev_val == TRUE ? "-J preview" : "");

	if (duration != 0)
	{
		fprintf (outFile, "&\n/tmp/gv4l-sleep.sh\n");
		fprintf (outFile, "\necho Done > /tmp/gv4l.temp\n");
	}	
	else
		fprintf (outFile, "\necho Done > /tmp/gv4l.temp\n");

	fclose (outFile);

	
	if (duration != 0)
	{
  		outFile = fopen ("/tmp/gv4l-sleep.sh", "w");
		fprintf (outFile, "#!/bin/bash\n");
		fprintf (outFile, "sleep %dm\nkillall -2 transcode\nkillall -3 gv4l\nrm -rf /tmp/gv4l*\n", duration);
		fclose (outFile);
	}
	
	//run script
  	system ("chmod +x /tmp/gv4l.sh");
	system ("chmod +x /tmp/gv4l-sleep.sh 2>/dev/null");
  	system ("/tmp/gv4l.sh&");
  }
  else //resume recording
  {
  	outFile = fopen ("/tmp/gv4l.sh", "w");
  	fprintf (outFile, "#!/bin/bash\n");
  	fprintf (outFile,
			"transcode -i %s -p %s -V -u 100 %s %s -y %s --import_v4l %s -o %s.append %s %s %s %s %s",
			vdev_val, adev_val, p_size, fps_val, cod_val, chan_val,
			file_val, vbit_val, abit_val, agn_val, deinter,
			prev_val == TRUE ? "-J preview" : "");
	if (duration != 0)
	  fprintf (outFile, "&\n/tmp/gv4l-sleep.sh\n");
	else
	  fprintf (outFile, "\n");
  
  	fprintf (outFile,
		"avimerge -o %s.new -i %s %s.append 2>/dev/null||echo Done > /tmp/gv4l.temp|exit\n",
		file_val, file_val, file_val);
  	fprintf (outFile, "rm %s %s.append\n", file_val, file_val);
  	fprintf (outFile, "mv %s.new %s\n", file_val, file_val);
	fprintf (outFile, "echo Done > /tmp/gv4l.temp\n");
  	
	fclose (outFile);

	if (duration != 0)
	{
		outFile = fopen ("/tmp/gv4l-sleep.sh", "w");
		fprintf (outFile, "#!/bin/bash\n");
		fprintf (outFile, "sleep %dm\nkillall -2 transcode\nkillall -3 gv4l\nrm -rf /tmp/gv4l*\n", duration);
		fclose (outFile);
	}

	//run script
	system ("chmod +x /tmp/gv4l.sh");
	system ("chmod +x /tmp/gv4l-sleep.sh 2>/dev/null");
  	system ("/tmp/gv4l.sh&");
  }


  //change status
  style->fg[GTK_STATE_NORMAL] = red;
  //  style->font = gdk_font_load("10x20");
  gtk_entry_set_text(GTK_ENTRY (status), "Recording...");
  gtk_widget_set_style(GTK_WIDGET (status), style);
  sleep (1);
  
  //remove check file
  system("rm -rf /tmp/trr");
  //create new check file if transcode is running
  system ("ps -A|grep transcode >/tmp/trr || rm -rf /tmp/trr");
  
  //reset status if transcode not running
  if (fopen ("/tmp/trr", "r") == NULL)
  {
  	style0->fg[GTK_STATE_NORMAL] = green;
  	// style->font = gdk_font_load("10x20");
  	gtk_entry_set_text(GTK_ENTRY (status), "Idle.");
  	gtk_widget_set_style(GTK_WIDGET (status), style0);
  }
}

//call the record function from menu
void
on_start_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  on_start_clicked ((GtkButton *) menuitem, menuitem);
}





//stop function
void
on_stop_clicked (GtkButton * button, gpointer user_data)
{
  //lookup widgets
  GtkWidget *status = lookup_widget (GTK_WIDGET (button), "status");
  GtkStyle *style = gtk_style_new();
  GdkColor  green = {0, 0, 35335, 0};

  //stop transcode
  system ("killall -2 transcode 2>/dev/null || echo Done > /tmp/gv4l.temp");
  system ("killall -9 gv4l-sleep.sh 2>/dev/null");
  //wait until scripts are done
  do
    {
      system ("sleep 0.5 2>/dev/null || sleep 0,5");
    }
  while (fopen ("/tmp/gv4l.temp", "r") == NULL);
  system ("sleep 0.1 2>/dev/null || sleep 0,1");
 
  //remove temp files
  system ("rm -rf /tmp/gv4l*");
  system ("rm -rf /tmp/trr");

  //reset status
  style->fg[GTK_STATE_NORMAL] = green;
  //  style->font = gdk_font_load("10x20");
  gtk_entry_set_text(GTK_ENTRY (status), "Idle.");
  gtk_widget_set_style(GTK_WIDGET (status), style);

}


//call stop function from menu
void
on_stop_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  on_stop_clicked ((GtkButton *) menuitem, menuitem);

}





//play file function
void
on_play_clicked                        (GtkButton       *button,
                                        gpointer         user_data)
{
  //define variables
  FILE *inFile;
  gchar file_val[250];
  gchar player[250];
  gchar command[250];
  //lookup widget
  GtkWidget *file = lookup_widget (GTK_WIDGET (button), "file_val");
  strncpy (file_val, gtk_entry_get_text (GTK_ENTRY (file)), 250);

  //see what player we got selected
  inFile = fopen("/tmp/player-gv4l", "r");
  fscanf (inFile, "%s", player);
  fclose (inFile);
  //start player if there's one set
  if (strcmp (player, "none")!=0 || fopen (player, "r")!=NULL)
  {
  	strcpy (command, player);
  	strcat (command," ");
  	strcat (command, file_val);
  	strcat (command, "&");
  	system (command);
  }
  else //if no player popup selection dialog
  {
  	GtkWidget *noplay;
  	noplay = create_noplay ();
  	gtk_widget_show (noplay);
  	exit;
  }
}

//call the play file function from menu
void
on_play_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  on_play_clicked ((GtkButton *) menuitem, menuitem);
}





//browse file/player window
void
on_browse_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *fileselection1;

   fileselection1 = create_fileselection1 ();
   gtk_widget_show (fileselection1);
   exit;
}

//browse file/player from menu
void
on_browse_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  on_browse_clicked ((GtkButton *) menuitem, menuitem);

}

//file/player selection
void
on_ok_file_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  //define variables	
  FILE *outFile;
  gchar *filename;
  GtkWidget *file_selection1 = lookup_widget (GTK_WIDGET (button), "fileselection1");
  GtkWidget *file_val = lookup_widget (gv4l, "file_val");
  filename = gtk_file_selection_get_filename(GTK_FILE_SELECTION(file_selection1));
      
  if (fopen("/tmp/gv4l-plr", "r")==NULL) //select filename
  {
  	gtk_entry_set_text ((GtkEntry *) file_val, filename);
  }
  else //select player
  {
  	system("rm -rf /tmp/gv4l-plr");
  	outFile = fopen ("/tmp/player-gv4l", "w");
  	fprintf (outFile, "%s\n" ,filename);
  	fclose (outFile);
  }
  
  //close file selection window
  gtk_widget_destroy(file_selection1);

}

//cancel file/player selection
void
on_cancel_file_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  //close window
  GtkWidget *fileselection1 = lookup_widget (GTK_WIDGET (button), "fileselection1");
  gtk_widget_destroy(fileselection1);
}


//select player activated
void
on_select_player_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  system("echo select_plr > /tmp/gv4l-plr");
  on_browse_clicked ((GtkButton *) menuitem, menuitem);
}


//select player activated
void
on_select_player_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  system("echo select_plr > /tmp/gv4l-plr");
  on_browse_clicked ((GtkButton *) button, button);
}





//save settings to file
void
on_save_settings1_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  //define variables
  FILE *outFile;
  FILE *inFile;
  gchar player[250]="none";

  gchar vdev_val[250];
  gchar adev_val[250];
  gchar p_size[250];
  gchar fps_val[250];
  gchar cod_val[250];
  gchar chan_val[250];
  gchar file_val[250];
  gchar vbit_val[250];
  gchar abit_val[250];
  gchar agn_val[250];
  gint prev_val;
  gboolean prev_val1;
  gchar rec_dur[250];
  gchar deinter[250];

  //lookup widgets
  GtkWidget *vdev = lookup_widget (GTK_WIDGET (menuitem), "vdev_val");
  GtkWidget *adev = lookup_widget (GTK_WIDGET (menuitem), "adev_val");
  GtkWidget *size = lookup_widget (GTK_WIDGET (menuitem), "p_size");
  GtkWidget *fps = lookup_widget (GTK_WIDGET (menuitem), "fps_val");
  GtkWidget *cod = lookup_widget (GTK_WIDGET (menuitem), "combo_entry1");
  GtkWidget *chan = lookup_widget (GTK_WIDGET (menuitem), "chan_val");
  GtkWidget *file = lookup_widget (GTK_WIDGET (menuitem), "file_val");
  GtkWidget *vbit = lookup_widget (GTK_WIDGET (menuitem), "vbit_val");
  GtkWidget *abit = lookup_widget (GTK_WIDGET (menuitem), "abit_val");
  GtkWidget *agn = lookup_widget (GTK_WIDGET (menuitem), "agn_val");
  GtkWidget *prev = lookup_widget (GTK_WIDGET (menuitem), "prev_val");
  GtkWidget *rec = lookup_widget (GTK_WIDGET (menuitem), "recTime");
  GtkWidget *inter = lookup_widget (GTK_WIDGET (menuitem), "de_inter");

  //read values
  strncpy (vdev_val, gtk_entry_get_text (GTK_ENTRY (vdev)), 250);
  strncpy (adev_val, gtk_entry_get_text (GTK_ENTRY (adev)), 250);
  strncpy (p_size, gtk_entry_get_text (GTK_ENTRY (size)), 250);
  strncpy (fps_val, gtk_entry_get_text (GTK_ENTRY (fps)), 250);
  strncpy (cod_val, gtk_entry_get_text (GTK_ENTRY (cod)), 250);
  strncpy (chan_val, gtk_entry_get_text (GTK_ENTRY (chan)), 250);
  strncpy (file_val, gtk_entry_get_text (GTK_ENTRY (file)), 250);
  strncpy (vbit_val, gtk_entry_get_text (GTK_ENTRY (vbit)), 250);
  strncpy (abit_val, gtk_entry_get_text (GTK_ENTRY (abit)), 250);
  strncpy (agn_val, gtk_entry_get_text (GTK_ENTRY (agn)), 250);
  strncpy (rec_dur, gtk_entry_get_text (GTK_ENTRY (rec)), 250);
  strncpy (deinter, gtk_entry_get_text (GTK_ENTRY (inter)), 250);
  prev_val1 = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (prev));

  if (prev_val1 == TRUE)
  {
	prev_val = 1;
  }
  else
  {
	prev_val = 0;
  }

  //get player info if one is selected
  if (fopen ("/tmp/player-gv4l", "r")!=NULL)
  {
	inFile = fopen ("/tmp/player-gv4l", "r");
	fscanf (inFile, "%s", player);
	fclose (inFile);
  }

  //write config file
  outFile = fopen (config_file, "w");
  fprintf (outFile, "%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%d\n%s\n%s\n%s\n", vdev_val,
	   adev_val, p_size, fps_val, cod_val, vbit_val, abit_val, agn_val,
	   chan_val, file_val, prev_val, player, deinter, rec_dur);
  fclose (outFile);
}





//load program default settings
void
on_revert_to_defaults1_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  char config[250]; //config file
  
  //store config file to other variable
  strcpy (config, config_file);
  //remove config file value
  strcpy (config_file, "");
  //run program init function
  on_gv4l_show ((GtkWidget *) menuitem, menuitem);
  //restore config file value
  strcpy (config_file, config);
}





//reload the settings from file
void
on_reload_saved_settings1_activate     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  on_gv4l_show ((GtkWidget *) menuitem, menuitem);
}





//show about box
void
on_about_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  GtkWidget *about;
  about = create_about ();
  gtk_widget_show (about);
}





//program exit
gboolean
on_gv4l_delete_event (GtkWidget * widget,
		      GdkEvent * event, gpointer user_data)
{
  //stop transcode if running
  system ("killall -2 transcode 2>/dev/null");
  system ("killall -9 gv4l-sleep.sh 2>/dev/null");
  //remove temporary files
  system ("rm -rf /tmp/gv4l*");
  system ("rm -rf /tmp/player-gv4l");
  system("rm -rf /tmp/trr");
  // Remove leftovers from DivX5 because of possible permissions problems
  // Explanations at http://www.theorie.physik.uni-goettingen.de/pipermail/transcode-users/2002-May/002291.html
  system("rm -rf \"c:\\trace_b.txt\"");
  //exit
  on_btnClose_clicked ((GtkButton *) widget, widget);
  gtk_exit (0);
  return 1;
}


//program exit
void
on_exit1_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  //stop transcode if running
  system ("killall -2 transcode 2>/dev/null");
  system ("killall -9 gv4l-sleep.sh 2>/dev/null");
  //remove temporary files
  system ("rm -rf /tmp/gv4l*");
  system ("rm -rf /tmp/player-gv4l");
  system("rm -rf /tmp/trr");
  // Remove leftovers from DivX5 because of possible permissions problems
  // Explanations at http://www.theorie.physik.uni-goettingen.de/pipermail/transcode-users/2002-May/002291.html
  system("rm -rf \"c:\\trace_b.txt\"");
  //exit
  on_btnClose_clicked ((GtkButton *) menuitem, menuitem);
  gtk_exit (0);
}


//program exit
void
on_exit_no_tr_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  //stop transcode if running
  system ("killall -2 transcode 2>/dev/null");
  system ("killall -9 gv4l-sleep.sh 2>/dev/null");
  //remove temporary files
  system ("rm -rf /tmp/gv4l*");
  system ("rm -rf /tmp/player-gv4l");
  system("rm -rf /tmp/trr");
  // Remove leftovers from DivX5 because of possible permissions problems
  // Explanations at http://www.theorie.physik.uni-goettingen.de/pipermail/transcode-users/2002-May/002291.html
  system("rm -rf \"c:\\trace_b.txt\"");
  //exit
  on_btnClose_clicked ((GtkButton *) button, button);
  gtk_exit (1);
}

//show the schedule manager
void
on_shedule_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  on_schedule_clicked ((GtkButton *) menuitem, menuitem);
}

//show the schedule manager
void
on_schedule_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  gchar *home = g_get_home_dir();
  gchar tmp_file[250]; //temp file
  gchar config[250]; //config file
  gchar command[250]; //command to be written
  gint i;
  
  GtkWidget *schedule;
  GtkWidget *cmd;

  //create window
  schedule = create_schedule ();
  gtk_widget_show (schedule);
  //lookup widget after it is created
  cmd = lookup_widget (schedule, "txtCmd");
  
  //set the default schedule file
  strcpy (sch_file, home);
  strcat (sch_file, "/.gv4l-schedule");
  //see if we have to create non-default schedule file
  if (fopen (sch_file, "r"))
  {
	for (i=1;i<10000;i++)
	{
		sprintf (tmp_file, "%s-%d", sch_file, i);
		if (fopen (tmp_file, "r") == NULL)
		{
			strcpy (sch_file, tmp_file);
			i = 10000;
		}
	}
  }

  //store config file to other variable
  strcpy (config, config_file);
  //set the schedule file as config file
  strcpy (config_file, sch_file);
  //run program init function
  on_save_settings1_activate ((GtkMenuItem *) button, button);
  //restore config file value
  strcpy (config_file, config);
  
  //write the command to the appropriate textbox
  sprintf(command, "gv4l --file %s --record", sch_file);
  gtk_entry_set_text (GTK_ENTRY (cmd), command);
}

//close the schedule manager
void
on_btnClose_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  //vars
  FILE *inFile;
  gchar cron_line[250];
  gchar schfile[250];
  GtkWidget *schedule = lookup_widget (GTK_WIDGET (button), "schedule");
 
  strcpy (schfile, sch_file);
  //make sure we got " " after the filename in cron
  strcat (schfile, " ");
  //put cron to temp file
  system ("crontab -l > /tmp/gv4l-cron");
  inFile = fopen ("/tmp/gv4l-cron", "r");
  do
  {
	  strcpy (cron_line, "unknown");
	  fgets (cron_line, 250, inFile);
	  
	  //preserve schedule file if found in cron
	  if (strstr (cron_line, schfile))
		  strcpy (sch_file, "/tmp/gv4l_needs_this_file");
	  //remove schedule file if not on cron
	  if (feof (inFile)!=0)
		  remove (sch_file);
  }
  while (feof(inFile)==0);

  fclose (inFile);
  remove ("/tmp/gv4l-cron");
			  
  //close window
  gtk_widget_destroy(schedule);
}

//make sure we don't have useless schedules
gboolean
on_schedule_delete_event               (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  on_btnClose_clicked ((GtkButton *) widget, widget);
  return FALSE;
}



//scheduler weekdays selection
//disable select all
void
on_chkMon_pressed                      (GtkButton *button,
                                        gpointer         user_data)
{
  GtkWidget *AllDays = lookup_widget (GTK_WIDGET (button), "chkAllDays");
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllDays), FALSE);
}

//disable select all
void
on_chkTue_pressed                      (GtkButton *button,
                                        gpointer         user_data)
{
  GtkWidget *AllDays = lookup_widget (GTK_WIDGET (button), "chkAllDays");
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllDays), FALSE);
}

//disable select all
void
on_chkWed_pressed                      (GtkButton *button,
                                        gpointer         user_data)
{
  GtkWidget *AllDays = lookup_widget (GTK_WIDGET (button), "chkAllDays");
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllDays), FALSE);
}

//disable select all
void
on_chkThu_pressed                      (GtkButton *button,
                                        gpointer         user_data)
{
  GtkWidget *AllDays = lookup_widget (GTK_WIDGET (button), "chkAllDays");
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllDays), FALSE);
}

//disable select all
void
on_chkFri_pressed                      (GtkButton *button,
                                        gpointer         user_data)
{
  GtkWidget *AllDays = lookup_widget (GTK_WIDGET (button), "chkAllDays");
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllDays), FALSE);
}

//disable select all
void
on_chkSat_pressed                      (GtkButton *button,
                                        gpointer         user_data)
{
  GtkWidget *AllDays = lookup_widget (GTK_WIDGET (button), "chkAllDays");
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllDays), FALSE);
}

//disable select all
void
on_chkSun_pressed                      (GtkButton *button,
                                        gpointer         user_data)
{
  GtkWidget *AllDays = lookup_widget (GTK_WIDGET (button), "chkAllDays");
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllDays), FALSE);
}

//disable individual weekdays and enable select all
void
on_chkAllDays_pressed                  (GtkButton *button,
                                        gpointer         user_data)
{
  GtkWidget *Mon = lookup_widget (GTK_WIDGET (button), "chkMon");
  GtkWidget *Tue = lookup_widget (GTK_WIDGET (button), "chkTue");
  GtkWidget *Wed = lookup_widget (GTK_WIDGET (button), "chkWed");
  GtkWidget *Thu = lookup_widget (GTK_WIDGET (button), "chkThu");
  GtkWidget *Fri = lookup_widget (GTK_WIDGET (button), "chkFri");
  GtkWidget *Sat = lookup_widget (GTK_WIDGET (button), "chkSat");
  GtkWidget *Sun = lookup_widget (GTK_WIDGET (button), "chkSun");

  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Mon), FALSE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Tue), FALSE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Wed), FALSE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Thu), FALSE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Fri), FALSE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Sat), FALSE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Sun), FALSE);
}



//scheduler months selection
//disable select all
void
on_chkJan_pressed                      (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *AllMths = lookup_widget (GTK_WIDGET (button), "chkAllMths");
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllMths), FALSE);
}

//disable select all
void
on_chkJul_pressed                      (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *AllMths = lookup_widget (GTK_WIDGET (button), "chkAllMths");
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllMths), FALSE);
}

//disable select all
void
on_chkFeb_pressed                      (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *AllMths = lookup_widget (GTK_WIDGET (button), "chkAllMths");
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllMths), FALSE);
}

//disable select all
void
on_chkAug_pressed                      (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *AllMths = lookup_widget (GTK_WIDGET (button), "chkAllMths");
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllMths), FALSE);
}

//disable select all
void
on_chkMar_pressed                      (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *AllMths = lookup_widget (GTK_WIDGET (button), "chkAllMths");
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllMths), FALSE);
}

//disable select all
void
on_chkSep_pressed                      (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *AllMths = lookup_widget (GTK_WIDGET (button), "chkAllMths");
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllMths), FALSE);
}

//disable select all
void
on_chkApr_pressed                      (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *AllMths = lookup_widget (GTK_WIDGET (button), "chkAllMths");
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllMths), FALSE);
}

//disable select all
void
on_chkOct_pressed                      (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *AllMths = lookup_widget (GTK_WIDGET (button), "chkAllMths");
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllMths), FALSE);
}

//disable select all
void
on_chkMay_pressed                      (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *AllMths = lookup_widget (GTK_WIDGET (button), "chkAllMths");
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllMths), FALSE);
}

//disable select all
void
on_chkNov_pressed                      (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *AllMths = lookup_widget (GTK_WIDGET (button), "chkAllMths");
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllMths), FALSE);
}

//disable select all
void
on_chkJun_pressed                      (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *AllMths = lookup_widget (GTK_WIDGET (button), "chkAllMths");
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllMths), FALSE);
}

//disable select all
void
on_chkDec_pressed                      (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *AllMths = lookup_widget (GTK_WIDGET (button), "chkAllMths");
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllMths), FALSE);
}

//disable individual months and enable select all
void
on_chkAllMths_pressed                  (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *Jan = lookup_widget (GTK_WIDGET (button), "chkJan");
  GtkWidget *Feb = lookup_widget (GTK_WIDGET (button), "chkFeb");
  GtkWidget *Mar = lookup_widget (GTK_WIDGET (button), "chkMar");
  GtkWidget *Apr = lookup_widget (GTK_WIDGET (button), "chkApr");
  GtkWidget *May = lookup_widget (GTK_WIDGET (button), "chkMay");
  GtkWidget *Jun = lookup_widget (GTK_WIDGET (button), "chkJun");
  GtkWidget *Jul = lookup_widget (GTK_WIDGET (button), "chkJul");
  GtkWidget *Aug = lookup_widget (GTK_WIDGET (button), "chkAug");
  GtkWidget *Sep = lookup_widget (GTK_WIDGET (button), "chkSep");
  GtkWidget *Oct = lookup_widget (GTK_WIDGET (button), "chkOct");
  GtkWidget *Nov = lookup_widget (GTK_WIDGET (button), "chkNov");
  GtkWidget *Dec = lookup_widget (GTK_WIDGET (button), "chkDec");

  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Jan), FALSE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Feb), FALSE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Mar), FALSE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Apr), FALSE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (May), FALSE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Jun), FALSE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Jul), FALSE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Aug), FALSE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Sep), FALSE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Oct), FALSE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Nov), FALSE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Dec), FALSE);
}





//create cron job
void
on_btnCreate_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  FILE *outFile;
  FILE *inFile;
  gchar cron_line[500], cron_tit[500] = "", disabled[500] = "";
  int display;
  int fnd_dis = 0;
  int fnd_path = 0;
  
  gchar month[250] = "", wkday[250] = "";
  gchar ttl[250], hr[250], min[250], day[250], cmd[250], dsp[250];
  gboolean jan, feb, mar, apr, may, jun, jul, aug, sep, oct, nov, dec,
  		mon, tue, wed, thu, fri, sat, sun;
  //lookup widgets
  GtkWidget *wttl = lookup_widget (GTK_WIDGET (button), "txtTitle");
  GtkWidget *whr = lookup_widget (GTK_WIDGET (button), "cbohrs");
  GtkWidget *wmin = lookup_widget (GTK_WIDGET (button), "cbomins");
  GtkWidget *wday = lookup_widget (GTK_WIDGET (button), "cboday");
  GtkWidget *wjan = lookup_widget (GTK_WIDGET (button), "chkJan");
  GtkWidget *wfeb = lookup_widget (GTK_WIDGET (button), "chkFeb");
  GtkWidget *wmar = lookup_widget (GTK_WIDGET (button), "chkMar");
  GtkWidget *wapr = lookup_widget (GTK_WIDGET (button), "chkApr");
  GtkWidget *wmay = lookup_widget (GTK_WIDGET (button), "chkMay");
  GtkWidget *wjun = lookup_widget (GTK_WIDGET (button), "chkJun");
  GtkWidget *wjul = lookup_widget (GTK_WIDGET (button), "chkJul");
  GtkWidget *waug = lookup_widget (GTK_WIDGET (button), "chkAug");
  GtkWidget *wsep = lookup_widget (GTK_WIDGET (button), "chkSep");
  GtkWidget *woct = lookup_widget (GTK_WIDGET (button), "chkOct");
  GtkWidget *wnov = lookup_widget (GTK_WIDGET (button), "chkNov");
  GtkWidget *wdec = lookup_widget (GTK_WIDGET (button), "chkDec");
  GtkWidget *wMon = lookup_widget (GTK_WIDGET (button), "chkMon");
  GtkWidget *wTue = lookup_widget (GTK_WIDGET (button), "chkTue");
  GtkWidget *wWed = lookup_widget (GTK_WIDGET (button), "chkWed");
  GtkWidget *wThu = lookup_widget (GTK_WIDGET (button), "chkThu");
  GtkWidget *wFri = lookup_widget (GTK_WIDGET (button), "chkFri");
  GtkWidget *wSat = lookup_widget (GTK_WIDGET (button), "chkSat");
  GtkWidget *wSun = lookup_widget (GTK_WIDGET (button), "chkSun");
  GtkWidget *wcmd = lookup_widget (GTK_WIDGET (button), "txtCmd");
  GtkWidget *wdsp = lookup_widget (GTK_WIDGET (button), "txtDisplay");

  //get variables
  strncpy (ttl, gtk_entry_get_text (GTK_ENTRY (wttl)), 250);
  strncpy (hr, gtk_entry_get_text (GTK_ENTRY (whr)), 250);
  strncpy (min, gtk_entry_get_text (GTK_ENTRY (wmin)), 250);
  strncpy (day, gtk_entry_get_text (GTK_ENTRY (wday)), 250);
  jan = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wjan));
  feb = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wfeb));
  mar = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wmar));
  apr = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wapr));
  may = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wmay));
  jun = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wjun));
  jul = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wjul));
  aug = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (waug));
  sep = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wsep));
  oct = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (woct));
  nov = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wnov));
  dec = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wdec));
  mon = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wMon));
  tue = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wTue));
  wed = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wWed));
  thu = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wThu));
  fri = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wFri));
  sat = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wSat));
  sun = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wSun));
  strncpy (cmd, gtk_entry_get_text (GTK_ENTRY (wcmd)), 250);
  strncpy (dsp, gtk_entry_get_text (GTK_ENTRY (wdsp)), 250);


  //see what months are selected
  if (jan == TRUE && strcmp (month, "")==0)
	  strcpy (month, "1");
  else if (jan == TRUE)
	  strcat (month, ",1");
  
  if (feb == TRUE && strcmp (month, "")==0)
	  strcpy (month, "2");
  else if (feb == TRUE)
	  strcat (month, ",2");
  
  if (mar == TRUE && strcmp (month, "")==0)
	  strcpy (month, "3");
  else if (mar == TRUE)
	  strcat (month, ",3");
  
  if (apr == TRUE && strcmp (month, "")==0)
	  strcpy (month, "4");
  else if (apr == TRUE)
	  strcat (month, ",4");
  
  if (may == TRUE && strcmp (month, "")==0)
	  strcpy (month, "5");
  else if (may == TRUE)
	  strcat (month, ",5");
  
  if (jun == TRUE && strcmp (month, "")==0)
	  strcpy (month, "6");
  else if (jun == TRUE)
	  strcat (month, ",6");
  
  if (jul == TRUE && strcmp (month, "")==0)
	  strcpy (month, "7");
  else if (jul == TRUE)
	  strcat (month, ",7");
  
  if (aug == TRUE && strcmp (month, "")==0)
	  strcpy (month, "8");
  else if (aug == TRUE)
	  strcat (month, ",8");
  
  if (sep == TRUE && strcmp (month, "")==0)
	  strcpy (month, "9");
  else if (sep == TRUE)
	  strcat (month, ",9");
  
  if (oct == TRUE && strcmp (month, "")==0)
	  strcpy (month, "10");
  else if (oct == TRUE)
	  strcat (month, ",10");
  
  if (nov == TRUE && strcmp (month, "")==0)
	  strcpy (month, "11");
  else if (nov == TRUE)
	  strcat (month, ",11");
  
  if (dec == TRUE && strcmp (month, "")==0)
	  strcpy (month, "12");
  else if (dec == TRUE)
	  strcat (month, ",12");

  if (strcmp (month, "")==0 || strcmp (month, "1,2,3,4,5,6,7,8,9,10,11,12")==0)
	  strcpy (month, "*");



  //see what days are selected
  if (mon == TRUE && strcmp (wkday, "")==0)
	  strcpy (wkday, "1");
  else if (mon == TRUE)
	  strcat (wkday, ",1");
  
  if (tue == TRUE && strcmp (wkday, "")==0)
	  strcpy (wkday, "2");
  else if (tue == TRUE)
	  strcat (wkday, ",2");
  
  if (wed == TRUE && strcmp (wkday, "")==0)
	  strcpy (wkday, "3");
  else if (wed == TRUE)
	  strcat (wkday, ",3");
  
  if (thu == TRUE && strcmp (wkday, "")==0)
	  strcpy (wkday, "4");
  else if (thu == TRUE)
	  strcat (wkday, ",4");
  
  if (fri == TRUE && strcmp (wkday, "")==0)
	  strcpy (wkday, "5");
  else if (fri == TRUE)
	  strcat (wkday, ",5");
  
  if (sat == TRUE && strcmp (wkday, "")==0)
	  strcpy (wkday, "6");
  else if (sat == TRUE)
	  strcat (wkday, ",6");
  
  if (sun == TRUE && strcmp (wkday, "")==0)
	  strcpy (wkday, "7");
  else if (sun == TRUE)
	  strcat (wkday, ",7");
  
  if (strcmp (wkday, "")==0 || strcmp (wkday, "1,2,3,4,5,6,7")==0)
	  strcpy (wkday, "*");


  //read crontab
  system ("crontab -l > /tmp/gv4l-cron");

  //convert display value to integer value
  display = atoi(dsp);
  
  //set/change the display & path variables, remove comments
  inFile = fopen ("/tmp/gv4l-cron", "r");
  outFile = fopen ("/tmp/gv4l-cron-new", "w");
  while (feof(inFile)==0)
  {
	  strcpy (cron_line, "");
	  fgets (cron_line, 500, inFile);
	  if (strstr (cron_line, "DISPLAY="))
	  {
	  	sprintf (cron_line, "# X display variable\nDISPLAY=\":%d.0\"\n", display);
		fputs (cron_line, outFile);
		fnd_dis = 1;
	  }
	  if (feof (inFile)!=0 && fnd_dis==0)
	  {
		sprintf (cron_line, "# X display variable\nDISPLAY=\":%d.0\"\n", display);
		fputs (cron_line, outFile);
	  }
	  
	  if (strstr (cron_line, "PATH="))
		  fnd_path = 1;
	  
	  
	  strncpy (disabled, cron_line, 2);
	  if (strstr (disabled, "#\\"))
	  {
		  fputs (cron_tit, outFile);
		  strcpy (cron_tit, "");
		  fputs (cron_line, outFile);
	  }
	  else if (strstr (disabled, "#"))
		  strcpy (cron_tit, cron_line);
	  else
	  {
		  fputs (cron_tit, outFile);
	  	  strcpy (cron_tit, "");
		  fputs (cron_line, outFile);
	  }


  }
  fclose (inFile);
  fclose (outFile);
  
  if (fnd_path==0)
  {
	  system ("echo \"# PATH variable for cron\" >> /tmp/gv4l-cron-new");
	  system ("echo \"PATH=$PATH\" >> /tmp/gv4l-cron-new");
  }

  //add job to crontab
  outFile = fopen ("/tmp/gv4l-cron-new", "a");
  fprintf (outFile, "# %s\n", ttl);
  fprintf (outFile, "%s	", min);
  fprintf (outFile, "%s	", hr);
  fprintf (outFile, "%s	", day);
  fprintf (outFile, "%s	", month);
  fprintf (outFile, "%s	", wkday);
  fprintf (outFile, "%s\n", cmd);
  fclose (outFile);
  system ("crontab /tmp/gv4l-cron-new");
  remove ("/tmp/gv4l-cron-new");
  remove ("/tmp/gv4l-cron");
  
  //refresh the list
  on_clist_show ((GtkWidget *) button, button);
}


void
on_clist_show                          (GtkWidget       *widget,
                                        gpointer         user_data)
{
  FILE *inFile;
  gchar cron_line[250];
  gchar disabled[250];
  gchar *pos;
  
  GtkWidget *clist = lookup_widget (GTK_WIDGET (widget), "clist");
  gchar *clist_content[2] = {enabled, value};

  gtk_clist_clear ((GtkCList *) clist);

  system ("crontab -l > /tmp/gv4l-cron-r");
  inFile = fopen ("/tmp/gv4l-cron-r", "r");
  while (feof(inFile)==0)
  {
	  strcpy (cron_line, "#");
	  fgets (cron_line, 250, inFile);

	  //get rid of newline char
	  if (strstr (cron_line, "\n"))
	  {
		  pos = strstr (cron_line, "\n");
		  strncpy (pos, " ", 1);
	  }
	  

	  strncpy (disabled, cron_line, 2);
	  if (strstr (disabled, "#\\"))
	  {
		  strcpy (enabled, "NO");
		  pos = cron_line + 2;
		  sprintf (value, "%s", pos);
		  gtk_clist_append ((GtkCList *) clist, clist_content);
	  }
	  else if (strstr (disabled, "#"))
	  {}
	  else
	  {
		  strcpy (enabled, "YES");
		  sprintf (value, "%s", cron_line);
		  gtk_clist_append ((GtkCList *) clist, clist_content);
	  }
  }
  fclose (inFile);
  remove ("/tmp/gv4l-cron-r");
}


void
on_schedule_show                       (GtkWidget       *widget,
                                        gpointer         user_data)
{
  on_clist_show ((GtkWidget *) widget, widget);
}


